package org.foxarmy.barcodescannerforemployees

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.util.Log
import android.view.LayoutInflater
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.core.content.ContextCompat
import androidx.core.content.ContextCompat.startActivity
import java.io.File

class AbstractProductView: LinearLayout {
    private var productLayout: ConstraintLayout
    private var productPicture: ImageView
    private var productNameField: TextView
    private var netWeightField: TextView
    private var categoryField: TextView
    private var unitField: TextView
    var isProductSelected = false

    constructor(activity: Activity, context: Context, productImageHash: String, productName: String, netWeight: Double, category: Int) : super(context) {

        val inflater:LayoutInflater = activity.layoutInflater
        inflater.inflate(R.layout.abstract_product_view, this)

        productLayout = findViewById(R.id.productLayout)
        productPicture = findViewById(R.id.productPicture)
        productNameField = findViewById(R.id.productNameView)
        netWeightField = findViewById(R.id.productNetWeightView)
        categoryField = findViewById(R.id.categoryView)
        unitField = findViewById(R.id.unitView)

        val thumbnailsDir = File(context.cacheDir, "thumbnails")
        thumbnailsDir.mkdirs()
        val imageUri = getImageUri(activity, File(thumbnailsDir, "$productImageHash.webp"))
        productPicture.setImageURI(imageUri)
        productPicture.rotation = 90f
        productPicture.setOnClickListener {
            Log.d("QWERTYUIOP", productImageHash)
            val fullscreenIntent = Intent(activity, FullscreenActivity::class.java)
            val extras = Bundle()
            extras.putString("imagehash", productImageHash)
            fullscreenIntent.putExtras(extras)
            startActivity(context, fullscreenIntent, extras)
        }

        productLayout.setOnClickListener {

        }

        productNameField.text = productName
        netWeightField.text = netWeight.toString()

        //TODO: category and units

        productLayout.setOnLongClickListener {
            isProductSelected = !isProductSelected
            this.background = ContextCompat.getDrawable(context, if (isProductSelected) R.drawable.outline_selected else R.drawable.outline)
            true
        }
    }
}